package figure;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * WsNX
 */
public class DefaultMatrix extends AbstractMatrix{

/** s̐ */
  protected int rowCount;

/** ̐ */
  protected int columnCount;

/** i[z */
  protected double data[][];

/**
 * s\z
 * @param size s̑傫
 */
  public DefaultMatrix(int size){
    this(size,size);
  }

/**
 * s\z
 * @param rowCount s̐
 * @param columnCount ̐
 */
  public DefaultMatrix(int rowCount,int columnCount){
    super();
    this.rowCount=rowCount;
    this.columnCount=columnCount;
    data=new double[rowCount][columnCount];
    for(int i=0;i<rowCount;i++){
      Arrays.fill(data[i],0.0);
    }
  }

//--------------------------------------------------------------------//
/**
 * s̐Ԃ
 * @return s̐
 */
  public int rowCount(){
    return rowCount;
  }

//--------------------------------------------------------------------//
/**
 * ̐Ԃ
 * @return ̐
 */
  public int columnCount(){
    return columnCount;
  }

//--------------------------------------------------------------------//
/**
 * Ԃ
 * @param row s
 * @param column 
 * @return w肳ꂽʒu̐
 */
  public double get(int row,int column){
    checkRange(row,column);
    return data[row][column];
  }

//--------------------------------------------------------------------//
/**
 * ɒlݒ肷
 * @param row s
 * @param column 
 * @param value ݒ肷l
 */
  public void set(int row,int column,double value){
    checkRange(row,column);
    data[row][column]=value;
    dataMax=Math.max(dataMax,Math.abs(value));
  }

//--------------------------------------------------------------------//
/**
 * ɒl
 * @param row s
 * @param column 
 * @param value l
 */
  public void add(int row,int column,double value){
    checkRange(row,column);
    data[row][column]+=value;
    dataMax=Math.max(dataMax,Math.abs(data[row][column]));
  }

//--------------------------------------------------------------------//
/**
 * s
 * @param m s
 */
  public void add(Matrix m){
    if((rowCount!=m.rowCount()) || (columnCount!=m.columnCount())){
      return;
    }
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	data[i][j]+=m.get(i,j);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * XJ[|
 * @param value |XJ[l
 */
  public void mul(double value){
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	data[i][j]*=value;
      }
    }
    dataMax*=Math.abs(value);
  }

//--------------------------------------------------------------------//
/**
 * s̐ςvZ
 * @param left ̍s
 * @param right E̍s
 * @return 2 ̍s̐
 */
  public static Matrix mul(Matrix left,Matrix right){
    if(left.columnCount()!=right.rowCount()) return null;
    int rowCount=left.rowCount();
    int columnCount=right.columnCount();
    int n=left.columnCount();
    Matrix matrix=new DefaultMatrix(rowCount,columnCount);
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	double sum=0.0;
      	for(int k=0;k<n;k++){
      	  sum+=left.get(i,k)*right.get(k,j);
      	}
      	matrix.set(i,j,sum);
      }
    }
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * s
 */
  public void init(){
    dataMax=0.0;
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	dataMax=Math.max(dataMax,Math.abs(data[i][j]));
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * PʍsԂ
 * @param size s̑傫
 * @return w肳ꂽ傫̒Pʍs
 */
  public static Matrix unitMatrix(int size){
    Matrix matrix=new DefaultMatrix(size);
    for(int i=0;i<size;i++){
      matrix.set(i,i,1.0);
    }
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * ]usԂ
 * @return ̍s̓]us
 */
  public Matrix transposition(){
    Matrix matrix=new DefaultMatrix(columnCount,rowCount);
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	matrix.set(j,i,data[i][j]);
      }
    }
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * w肵sEsԂ
 * @param row s
 * @param column 
 * @return ̍s񂩂w肳ꂽsEs
 */
  public Matrix eliminateRowColumn(int row,int column){
    checkRange(row,column);
    Matrix matrix=new DefaultMatrix(rowCount-1,columnCount-1);
    for(int i=0;i<row;i++){
      for(int j=0;j<column;j++){
      	matrix.set(i,j,data[i][j]);
      }
      for(int j=column+1;j<columnCount;j++){
      	matrix.set(i,j-1,data[i][j]);
      }
    }
    for(int i=row+1;i<rowCount;i++){
      for(int j=0;j<column;j++){
      	matrix.set(i-1,j,data[i][j]);
      }
      for(int j=column+1;j<columnCount;j++){
      	matrix.set(i-1,j-1,data[i][j]);
      }
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * w肵sEosԂ
 * @param size s̑傫
 * @param rows s̃CfbNXi[z
 * @param columns ̃CfbNXi[z
 * @return ̍s񂩂w肳ꂽsEos
 */
  public Matrix extructRowColumn(int size,int rows[],int columns[]){
    Matrix matrix=new DefaultMatrix(size);
    for(int i=0;i<size;i++){
      for(int j=0;j<size;j++){
      	matrix.set(i,j,data[rows[i]][columns[j]]);
      }
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * s񂪑Ώ̂ǂ𔻕ʂ
 * @return s񂪑Ώ̂łꍇ true
 */
  public boolean isSymmetry(){
    if(rowCount!=columnCount) return false;
    for(int i=0;i<rowCount-1;i++){
      for(int j=i+1;j<rowCount;j++){
      	if(data[i][j]!=data[j][i]) return false;
      }
    }
    return true;
  }

//--------------------------------------------------------------------//
/**
 * Jacobie @ŌŗLl߂
 * @param iterMax 񐔂̏
 */
  public Matrix eigenvalue(int iterMax){
    if(!isSymmetry()) return null;
    double tolerance=TOLERANCE*dataMax;
    Matrix m=(Matrix)clone();
    if(dataMax==0.0) return m;
    Matrix ev=unitMatrix(rowCount);
    for(int k=0;k<iterMax;k++){
      int im=0;
      int jm=0;
      double aMax=0.0;
      for(int i=0;i<rowCount-1;i++){
      	for(int j=i+1;j<rowCount;j++){
      	  if(Math.abs(m.get(i,j))>aMax){
      	    aMax=Math.abs(m.get(i,j));
      	    im=i;
      	    jm=j;
      	  }
      	}
      }
      if(aMax<tolerance) return m;
      double alpha=0.5*(m.get(im,im)-m.get(jm,jm));
      double beta=0.5/Math.sqrt(alpha*alpha+aMax*aMax);
      double cc2=0.5+Math.abs(alpha)*beta;
      double cs=-beta*m.get(im,jm);
      if(alpha<0.0) cs=-cs;
      double cc=Math.sqrt(cc2);
      double ss=cs/cc;
      double aij=2.0*(alpha*cc2-m.get(im,jm)*cs);
      double aii=m.get(jm,jm)+aij;
      double ajj=m.get(im,im)-aij;
      for(int i=0;i<rowCount;i++){
      	double a1=m.get(i,im)*cc-m.get(i,jm)*ss;
      	double a2=m.get(i,im)*ss+m.get(i,jm)*cc;
      	m.set(i,im,a1);
      	m.set(i,jm,a2);
      	m.set(im,i,a1);
      	m.set(jm,i,a2);
      	a1=ev.get(i,im)*cc-ev.get(i,jm)*ss;
      	a2=ev.get(i,im)*ss+ev.get(i,jm)*cc;
      	ev.set(i,im,a1);
      	ev.set(i,jm,a2);
      }
      m.set(im,im,aii);
      m.set(im,jm,0.0);
      m.set(jm,im,0.0);
      m.set(jm,jm,ajj);
    }
    return m;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    DefaultMatrix copy=(DefaultMatrix)super.clone();
    copy.data=new double[rowCount][columnCount];
    for(int i=0;i<rowCount;i++){
      System.arraycopy(data[i],0,copy.data[i],0,columnCount);
    }
    return copy;
  }
}
