package figure;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * xNgNX
 */
public class Vector implements Cloneable{

/** xNg̐̐ */
  public int size;

/** xNg̐i[z */
  public double data[];

/**
 * 0 xNg\z
 * @param size xNg̐̐
 */
  public Vector(int size){
    this.size=size;
    data=new double[size];
    Arrays.fill(data,0.0);
  }

/**
 * xNg\z
 * @param size xNg̐̐
 * @param data xNg̐i[z
 */
  public Vector(int size,double[] data){
    this.size=size;
    this.data=new double[size];
    System.arraycopy(data,0,this.data,0,size);
  }

//--------------------------------------------------------------------//
/**
 * ̐Ԃ
 * @return ̐
 */
  public int size(){
    return size;
  }

//--------------------------------------------------------------------//
/**
 * Ԃ
 * @param index ̃CfbNX
 * @return w肳ꂽ
 */
  public double get(int index){
    checkRange(index);
    return data[index];
  }

//--------------------------------------------------------------------//
/**
 * ݒ肷
 * @param index ̃CfbNX
 * @param value ̒l
 */
  public void set(int index,double value){
    checkRange(index);
    data[index]=value;
  }

//--------------------------------------------------------------------//
/**
 * ɒl
 * @param index ̃CfbNX
 * @param value l
 */
  public void add(int index,double value){
    checkRange(index);
    data[index]+=value;
  }

//--------------------------------------------------------------------//
/**
 * xNgavZ
 * @param v xNg
 */
  public void add(Vector v){
    if(size!=v.size()) return;
    for(int i=0;i<size;i++) data[i]+=v.get(i);
  }

//--------------------------------------------------------------------//
/**
 * xNgavZ
 * @param coef xNgɊ|W
 * @param v xNg
 */
  public void add(double coef,Vector v){
    if(size!=v.size()) return;
    for(int i=0;i<size;i++) data[i]+=coef*v.get(i);
  }

//--------------------------------------------------------------------//
/**
 * 0 xNgɐݒ肷
 */
  public void clear(){
    Arrays.fill(data,0.0);
  }

//--------------------------------------------------------------------//
/**
 * XJ[|
 * @param coef |XJ[l
 */
  public void mul(double coef){
    for(int i=0;i<size;i++){
      data[i]*=coef;
    }
  }

//--------------------------------------------------------------------//
/**
 * sƂ̐ςvZ
 * @param m ̃xNg̍|s
 * @return ς̃xNg
 */
  public Vector mul(Matrix m){
    if(size!=m.columnCount()) return null;
    int newsize=m.rowCount();
    double v[]=new double[newsize];
    for(int i=0;i<newsize;i++){
      v[i]=0.0;
      for(int j=0;j<size;j++){
      	v[i]+=m.get(i,j)*data[j];
      }
    }
    return new Vector(newsize,v);
  }

//--------------------------------------------------------------------//
/**
 * xNg̓ςvZ
 * @param v1 xNg 1
 * @param v2 xNg 2
 * @return ς̒l
 */
  public static double innerProduct(Vector v1,Vector v2){
    if(v1.size!=v2.size) return 0.0;
    double p=0.0;
    for(int i=0;i<v1.size;i++) p+=v1.get(i)*v2.get(i);
    return p;
  }

//--------------------------------------------------------------------//
/**
 * xNg̑傫vZ
 * @return xNg̑傫
 */
  public double magnitude(){
    return Math.sqrt(magnitudeSq());
  }

//--------------------------------------------------------------------//
/**
 * xNg̑傫 2 vZ
 * @return xNg̑傫 2 
 */
  public double magnitudeSq(){
    double mag=0.0;
    for(int i=0;i<size;i++) mag+=data[i]*data[i];
    return mag;
  }

//--------------------------------------------------------------------//
/**
 * f[^͈͂mF
 */
  public void checkRange(int index){
    if((index<0) || (size<=index))
      throw new IndexOutOfBoundsException();
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      Vector vector=(Vector)super.clone();
      vector.data=new double[size];
      System.arraycopy(data,0,vector.data,0,size);
      return vector;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int bit=size;
    for(int i=0;i<size;i++){
      long l=Double.doubleToLongBits(data[i]);
      bit=31*bit+(int)(l^(l>>>32));
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Vector</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Vector){
      Vector v=(Vector)obj;
      if(size==v.size()){
      	for(int i=0;i<size;i++){
      	  if(data[i]!=v.get(i)) return false;
      	}
      	return true;
      }
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuilder sb=new StringBuilder("Vector");
    for(int i=0;i<size;i++){
      sb.append('\t');
      sb.append(data[i]);
    }
    return sb.toString();
  }
}
