package figure;

//--------------------------------------------------------------------//
/**
 * 3 xNgNX
 */
public class Vector3D extends Tuple3D{

/**
 * ftHgl (0,0,0) ŃxNg\z
 */
  public Vector3D(){
    this(0.0,0.0,0.0);
  }

/**
 * w肵ăxNg\z
 * @param x <i>x</i> 
 * @param y <i>y</i> 
 * @param z <i>z</i> 
 */
  public Vector3D(double x,double y,double z){
    super(x,y,z);
  }

/**
 * W <code>t</code> ƓŃxNg\z
 * @param t QƂ <code>Tuple3D</code>
 */
  public Vector3D(Tuple3D t){
    this(t.x,t.y,t.z);
  }

/**
 * n_ƏI_w肵ăxNg\z
 * @param p0 n_
 * @param p1 I_
 */
  public Vector3D(Point3D p0,Point3D p1){
    this(p1.x-p0.x,p1.y-p0.y,p1.z-p0.z);
  }

//--------------------------------------------------------------------//
/**
 * XJ[{
 * @param a |XJ[
 */
  public void mul(double a){
    x*=a;
    y*=a;
    z*=a;
  }

//--------------------------------------------------------------------//
/**
 * xNg̑傫Ԃ
 * @return xNg̑傫
 */
  public double magnitude(){
    return Math.sqrt(x*x+y*y+z*z);
  }

//--------------------------------------------------------------------//
/**
 * xNg̑傫 2 Ԃ
 * @return xNg̑傫 2 
 */
  public double magnitudeSq(){
    return x*x+y*y+z*z;
  }

//--------------------------------------------------------------------//
/**
 * PʃxNg
 */
  public void normalize(){
    double mag=magnitude();
    if(mag<=Double.MIN_VALUE) return;
    x=x/mag;
    y=y/mag;
    z=z/mag;
  }

//--------------------------------------------------------------------//
/**
 * ɍW\Ԃ
 * @return ̃xNg̋ɍW\
 */
  public Vector3D polarCoordinates(){
    return new Vector3D(Math.sqrt(x*x+y*y),Math.atan2(y,x),z);
  }

//--------------------------------------------------------------------//
/**
 * W\Ԃ
 * @return ̃xNg̋W\
 */
  public Vector3D sphericalCoordinates(){
    double mag=magnitude();
    if(mag<=Double.MIN_VALUE) return new Vector3D();
    return new Vector3D(mag,Math.atan2(y,x),Math.acos(z/mag));
  }

//--------------------------------------------------------------------//
/**
 * xNg̓ςԂ
 * @param v ςvZxNg
 * @return ̃xNgƎw肳ꂽxNgƂ̓
 */
  public double dotProduct(Vector3D v){
    return dotProduct(v.x,v.y,v.z);
  }

//--------------------------------------------------------------------//
/**
 * xNg̓ςԂ
 * @param x xNg <i>x</i> 
 * @param y xNg <i>y</i> 
 * @param z xNg <i>z</i> 
 * @return ̃xNgƎw肳ꂽxNgƂ̓
 */
  public double dotProduct(double x,double y,double z){
    return this.x*x+this.y*y+this.z*z;
  }

//--------------------------------------------------------------------//
/**
 * xNg̓ςԂ
 * @param v1 ςvZxNg 1
 * @param v2 ςvZxNg 2
 * @return w肳ꂽxNg̓
 */
  public static double dotProduct(Vector3D v1,Vector3D v2){
    return v1.x*v2.x+v1.y*v2.y+v1.z*v2.z;
  }

//--------------------------------------------------------------------//
/**
 * xNg̊OςԂ
 * @param v OςvZxNg
 * @return ̃xNgƎw肳ꂽxNgƂ̊O
 */
  public Vector3D crossProduct(Vector3D v){
    return crossProduct(v.x,v.y,v.z);
  }

//--------------------------------------------------------------------//
/**
 * xNg̊OςԂ
 * @param x xNg <i>x</i> 
 * @param y xNg <i>y</i> 
 * @param z xNg <i>z</i> 
 * @return w肳ꂽxNg̓
 */
  public Vector3D crossProduct(double x,double y,double z){
    return new Vector3D(this.y*z-this.z*y,
      	      	      	this.z*x-this.x*z,
      	      	      	this.x*y-this.y*x);
  }

//--------------------------------------------------------------------//
/**
 * xNg̊OςԂ
 * @param v1 OςvZxNg
 * @param v2 OςvZxNg
 * @return w肳ꂽxNg̊O
 */
  public static Vector3D crossProduct(Vector3D v1,Vector3D v2){
    return new Vector3D(v1.y*v2.z-v1.z*v2.y,
      	      	      	v1.z*v2.x-v1.x*v2.z,
      	      	      	v1.x*v2.y-v1.y*v2.x);
  }

//--------------------------------------------------------------------//
/**
 * xNg̐pxԂ
 * @param v pxvZxNg
 * @return ̃xNgƎw肳ꂽxNgƂ̐px
 */
  public double angle(Vector3D v){
    double cc=dotProduct(v);
    double mag=magnitude()*v.magnitude();
    if(mag<=Double.MIN_VALUE){
      return 0.0;
    }
    else{
      return Math.acos(cc/mag);
    }
  }

//--------------------------------------------------------------------//
/**
 * xNg̐pxԂ
 * @param v1 pxvZxNg
 * @param v2 pxvZxNg
 * @return w肳ꂽxNg̐px
 */
  public static double angle(Vector3D v1,Vector3D v2){
    double cc=dotProduct(v1,v2);
    double mag=v1.magnitude()*v2.magnitude();
    if(mag<=Double.MIN_VALUE){
      return 0.0;
    }
    else{
      return Math.acos(cc/mag);
    }
  }

//--------------------------------------------------------------------//
/**
 * xNg̐̊pԂ
 * @param v1 ̊pvZxNg
 * @param v2 ̊pvZxNg
 * @param v3 ̊pvZxNg
 * @return w肳ꂽxNg̐̊p
 */
  public static double angle(Vector3D v1,Vector3D v2,Vector3D v3){
    Vector3D th1=v1.polarCoordinates();
    v2.rotZ(-th1.z);
    v2.rotY(-th1.y);
    v3.rotZ(-th1.z);
    v3.rotY(-th1.y);
    Vector3D th2=v2.polarCoordinates();
    Vector3D th3=v3.polarCoordinates();
    double angle=th3.z-th2.z;
    if(th2.y==th3.y){
      angle*=1.0-Math.cos(th2.y);
    }
    else{
      angle*=1.0-(Math.sin(th3.y)-Math.sin(th2.y))/(th3.y-th2.y);
    }
    return Math.abs(angle);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Vector3D\t"+x+"\t"+y+"\t"+z;
  }
}
