package figure.matrix;
import java.util.HashMap;

//--------------------------------------------------------------------//
/**
 * s@p[^
 */
public class MatrixSolveParameter{

/** s@p[^i[z */
  private static ParameterMap map=new ParameterMap();

/** s@̃p[^i[z */
  private double param[];

/**
 * s@p[^\z
 * @param p1 p[^ 1
 */
  private MatrixSolveParameter(double p1){
    param=new double[1];
    param[0]=p1;
  }

/**
 * s@p[^\z
 * @param p1 p[^ 1
 * @param p2 p[^ 2
 */
  private MatrixSolveParameter(double p1,double p2){
    param=new double[2];
    param[0]=p1;
    param[1]=p2;
  }

/**
 * s@p[^\z
 * @param p1 p[^ 1
 * @param p2 p[^ 2
 * @param p3 p[^ 3
 */
  private MatrixSolveParameter(double p1,double p2,double p3){
    param=new double[3];
    param[0]=p1;
    param[1]=p2;
    param[2]=p3;
  }

//--------------------------------------------------------------------//
/**
 * s@̃p[^Ԃ
 * @param method s@
 * @return s@̃p[^
 */
  public static MatrixSolveParameter
    getParameter(MatrixSolveMethod method){

    return map.get(method);
  }

//--------------------------------------------------------------------//
/**
 * s@̃p[^Ԃ
 * @param method s@
 * @return s@̃p[^i[z
 */
  public static double[] getParameters(MatrixSolveMethod method){
    MatrixSolveParameter p=getParameter(method);
    if(p==null){
      return null;
    }
    else{
      return p.param;
    }
  }

//--------------------------------------------------------------------//
/**
 * s@̃p[^ݒ肷
 * @param method s@
 * @param param s@̃p[^i[z
 */
  public static void setParameters(MatrixSolveMethod method,
      	      	      	      	   double param[]){
    MatrixSolveParameter p=getParameter(method);
    if((p==null) || (param==null)) return;
    p.param=new double[param.length];
    System.arraycopy(param,0,p.param,0,param.length);
  }

//--------------------------------------------------------------------//
/**
 * s@p[^
 */
  protected static class ParameterMap
    extends HashMap<MatrixSolveMethod,MatrixSolveParameter>{

    public ParameterMap(){
      super();
      put(MatrixSolveMethod.GAUSS,new MatrixSolveParameter(1.0E-10));
      put(MatrixSolveMethod.GAUSS_JORDAN,
      	  new MatrixSolveParameter(1.0E-10));
      put(MatrixSolveMethod.LU,new MatrixSolveParameter(1.0E-10));
      put(MatrixSolveMethod.SOR,
      	  new MatrixSolveParameter(1.0E-10,10000.0,1.0));
      put(MatrixSolveMethod.CG,
      	  new MatrixSolveParameter(1.0E-10,10000.0));
      put(MatrixSolveMethod.ILUCG,
      	  new MatrixSolveParameter(1.0E-10,10000.0));
    }
  }
}
