package rbf;
import figure.Vector;
import figure.matrix.DefaultMatrixSolver;
import figure.matrix.MatrixSolveException;

//--------------------------------------------------------------------//
/**
 * ˊ֐
 */
public abstract class Rbf{

/** _̐ */
  protected int dataCount;

/** ϐ̐ */
  protected int varCount;

/** _Wi[z */
  protected double c[][];

/** d݌Wi[z */
  protected double w[];

/**
 * ˊ֐Ԃ\z
 */
  protected Rbf(){
    dataCount=0;
    varCount=0;
  }

//--------------------------------------------------------------------//
/**
 * ֐̒lvZ
 * @param i _̃CfbNX
 * @param x _̍Wi[z
 * @return w肵_ł̊֐l
 */
  public abstract double basisFunction(int i,double x[]);

/**
 * a0ł̊֐̒lԂ
 * @return a0ł̊֐̒l
 */
  public abstract double atRZero();

//--------------------------------------------------------------------//
/**
 * _ݒ肷
 * @param x _Wi[z
 */
  public void setBasePoint(double x[][]){
    dataCount=x.length;
    varCount=x[0].length;
    c=new double[dataCount][varCount];
    for(int i=0;i<dataCount;i++){
      for(int j=0;j<varCount;j++){
      	c[i][j]=x[i][j];
      }
    }
    w=new double[dataCount+varCount+1];
  }

//--------------------------------------------------------------------//
/**
 * d݌Wݒ肷
 * @param f _ł̊֐li[z
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public void setWeight(double f[]) throws MatrixSolveException{
    int size=dataCount+varCount+1;
    DefaultMatrixSolver a=new DefaultMatrixSolver(size);
    Vector b=new Vector(size);
    for(int i=0;i<dataCount;i++){
      a.set(i,i,atRZero());
      for(int j=i+1;j<dataCount;j++){
      	double d=basisFunction(j,c[i]);
      	a.set(i,j,d);
      	a.set(j,i,d);
      }
      a.set(i,dataCount,1.0);
      a.set(dataCount,i,1.0);
      for(int j=0;j<varCount;j++){
      	a.set(i,dataCount+1+j,c[i][j]);
      	a.set(dataCount+1+j,i,c[i][j]);
      }
      b.set(i,f[i]);
    }
    b.set(dataCount,0.0);
    for(int j=0;j<varCount;j++){
      b.set(dataCount+1+j,0.0);
    }
    Vector x=a.solveByLUNoPreserv(b,1.0E-8);
    for(int i=0;i<size;i++){
      w[i]=x.get(i);
    }
  }

//--------------------------------------------------------------------//
/**
 * ֐lԂ
 * @param x _̍Wi[z
 * @return w肵_ł̊֐l
 */
  public double getValue(double x[]){
    double s=0.0;
    for(int i=0;i<dataCount;i++){
      s+=w[i]*basisFunction(i,x);
    }
    s+=w[dataCount];
    for(int j=0;j<varCount;j++){
      s+=w[dataCount+1+j]*x[j];
    }
    return s;
  }

//--------------------------------------------------------------------//
/**
 * _̋̂QԂ
 * @param i _̃CfbNX
 * @param x _̍Wi[z
 * @return w肵_̋̂Q
 */
  protected double disanceSq(int i,double x[]){
    double r2=0.0;
    for(int j=0;j<varCount;j++){
      r2+=(x[j]-c[i][j])*(x[j]-c[i][j]);
    }
    return r2;
  }
}
