package rbf;
import java.util.ArrayList;
import figure.Cube3D;
import figure.Point3D;
import figure.matrix.MatrixSolveException;

//--------------------------------------------------------------------//
/**
 * ˊ֐ԃf[^f
 */
public class RbfDataModel{

/** _Ԃ̍ŏ2 */
  protected static final double MIN_DISTANCE_SQ=1.0E-6;

/** _̃Xg */
  protected ArrayList<Point3D> points;

/** iq_ <i>x</i> W̕ */
  public int nx;

/** iq_ <i>y</i> W̕ */
  public int ny;

/** iq_i[z */
  protected Point3D grid[][];

/** iq͈ */
  protected Cube3D gridRange;

/**
 * ˊ֐ԃf[^f\z
 */
  public RbfDataModel(){
    points=new ArrayList<Point3D>();
    nx=-1;
    ny=-1;
    grid=new Point3D[0][0];
    gridRange=new Cube3D();
  }

//--------------------------------------------------------------------//
/**
 * _̐Ԃ
 * @return _̐
 */
  public int getPointCount(){
    return points.size();
  }

//--------------------------------------------------------------------//
/**
 * _Ԃ
 * @param index _̃CfbNX
 * @return w肳ꂽ_
 */
  public Point3D getPoint(int index){
    return points.get(index);
  }

//--------------------------------------------------------------------//
/**
 * _ǉ
 * @param newPoint Vǉ_
 */
  public void addPoint(Point3D newPoint){
    int count=getPointCount();
    for(int i=0;i<count;i++){
      Point3D p=getPoint(i);
      double dx=p.x-newPoint.x;
      double dy=p.y-newPoint.y;
      if((dx*dx+dy*dy)<=MIN_DISTANCE_SQ){
      	return;				// dȂ_͉Ȃ
      }
    }
    points.add(newPoint);
  }

//--------------------------------------------------------------------//
/**
 * iq_Ԃ
 * @param ix iq_ <i>x</i> W̃CfbNX
 * @param iy iq_ <i>y</i> W̃CfbNX
 * @return w肳ꂽiq_
 */
  public Point3D getGrid(int ix,int iy){
    return grid[ix][iy];
  }

//--------------------------------------------------------------------//
/**
 * iq͈͂Ԃ
 * @return iq͈
 */
  public Cube3D getRange(){
    return gridRange;
  }

//--------------------------------------------------------------------//
/**
 * f[^
 */
  public void clear(){
    points.clear();
    nx=-1;
    ny=-1;
    grid=new Point3D[0][0];
    gridRange=new Cube3D();
  }

//--------------------------------------------------------------------//
/**
 * iq_쐬
 * @param rbf a
 * @param nx iq_ <i>x</i> W̕
 * @param x0 iq_ <i>x</i> W̍ŏl
 * @param x1 iq_ <i>x</i> W̍ől
 * @param ny iq_ <i>y</i> W̕
 * @param y0 iq_ <i>y</i> W̍ŏl
 * @param y1 iq_ <i>y</i> W̍ől
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public void createGrid(Rbf rbf,int nx,double x0,double x1,
      	      	      	 int ny,double y0,double y1)
      	      	      	 throws MatrixSolveException{
    this.nx=nx;
    this.ny=ny;
    int count=getPointCount();
    double xx[][]=new double[count][2];
    double zz[]=new double[count];
    for(int i=0;i<count;i++){
      Point3D p=getPoint(i);
      xx[i][0]=p.x;
      xx[i][1]=p.y;
      zz[i]=p.z;
    }
    rbf.setBasePoint(xx);
    rbf.setWeight(zz);

    double dx=(x1-x0)/(double)nx;
    double dy=(y1-y0)/(double)ny;
    double zMin=0.0;
    double zMax=0.0;
    grid=new Point3D[nx+1][ny+1];
    for(int i=0;i<=nx;i++){
      double x=x0+dx*(double)i;
      for(int j=0;j<=ny;j++){
      	double y=y0+dy*(double)j;
      	double z=rbf.getValue(new double[]{x,y});
      	grid[i][j]=new Point3D(x,y,z);
      	if((i==0) && (j==0)){
      	  zMin=z;
      	  zMax=z;
      	}
      	else{
      	  zMin=Math.min(zMin,z);
      	  zMax=Math.max(zMax,z);
      	}
      }
    }
    gridRange.setBounds(x0,y0,zMin,x1-x0,y1-y0,zMax-zMin);
  }
}
